#include"adapt.h"

void error(char *msg)
{
    perror(msg);
    exit(1);
}

void print_help(char *app)
{
    fprintf(stderr, "usage %s machine:port <2^id_active_processors> \
<processingLimit [0-100]>\n", app);
    fprintf(stderr, "or    %s machine:port status\n", app);
    exit(0);
}

int main(int argc, char **argv, char **env)
{
    int portNumber;
    int sockfd;
    int bitmask;
    int procLimit;
    char msg[100];
    char *tempBuffer = NULL;
    char *token;
    char hostName[32];
    char serverMsg[256];

    if (argc < 3)
        print_help(argv[0]);

    /* Criando socket */
    token = strtok_r(argv[1], ":", &tempBuffer);
    strcpy(hostName, token);
    token = strtok_r(NULL, ":", &tempBuffer);
    portNumber = atoi(token);

    sockfd = createCliSocket(hostName, portNumber);
    if (sockfd == -1)
        error("ERRO ao criar socket");

    serverMsg[0] = '\0';

    /* Adaptação do servidor */
    if (argc > 3) {
        printf("Enviando pedido de adaptação...\n");
        /** Envia bitmask e processingLimit para o servidor */
        bitmask = atoi(argv[2]);
        procLimit = atoi(argv[3]);
        if (bitmask <= 0 || procLimit <= 0 || procLimit > 100) {
            sprintf(msg, "ERRO, Nao e possivel realizar reserva. Verifique \
os valores de bitmask e limite de processamento.\n");
            error(msg);
        }
        strcat(serverMsg, SERVER_ADAPT);
        sendClientOption(sockfd, serverMsg);
        sendServerAdaptMsg(sockfd, argv[2], argv[3]);
    } else if (strcmp(argv[2], "status") == 0) {
        /* Status do servidor */
        strcat(serverMsg, SERVER_STATUS);
        sendClientOption(sockfd, serverMsg);
    }

    return 0;
}
