/*******************************************************************************
 * 
 * Arquivo que manipula os temporizadores que sinalizam deadlines expirados para 
 * o controle de quanto de processamento é disponibilizado para cada processo.
 *
 ******************************************************************************/
#ifndef ALARMS_H
#define ALARMS_H

#include<signal.h>
#include<stdio.h>
#include<sys/types.h>
#include<sys/ioctl.h>
#include<fcntl.h>
#include<pthread.h>
#include<math.h>

#include "socket.h"
#include "reserve.h"
#include "monitor.h"
#include "server.h"

#define MIN_CONSERVING_SLICE 0.05

void alarmHandler(int sig);
void childHandler(int sig);
void createAlarms(pid_t pid, int sockfd);
void intHandler(int sig);
void *treatAlarms();
void *treatIOs();
void *treatMsgs(void *sockfd);

#endif
