/*******************************************************************************
 * 
 * Arquivo com métodos para a manipulação de envio/recebimento de mensagens via 
 * sockets.
 *
 ******************************************************************************/
#ifndef SOCKET_H
#define SOCKET_H

#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>
#include<unistd.h>
#include<strings.h>
#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include<semaphore.h>
#include<errno.h>

#define RESERVE "RESERVE"
#define SERVER_ADAPT "SERVER_ADAPT"
#define SERVER_STATUS "SERVER_STATUS"
#define KILL_PID "KILL_PID"

struct serverAdaptMsgDataStruct {
    int mask;
    int processingLimit;
};

struct reserveMsgDataStruct {
    char command[256];
    char *params[10];           /* No máximo dez parâmetros podem ser passados na linha de comando do cliente */
    pid_t pid;
};

int acceptConnection(int sockfd);
void closeSocket(int sockfd);
int createCliSocket(char *host, int portNumber);
int createSocketSemaphore();
int createSvrSocket();
void recvClientOption(int newsockfd, char *msg);
pid_t recvKillMsg(int newsockfd);
void recvReserveMsg(int newsockfd, struct reserveMsgDataStruct *msgData);
void recvServerAdaptMsg(int newsockfd, struct serverAdaptMsgDataStruct *msgData);
void sendClientOption(int sockfd, char *option);
void sendKillMsg(int sockfd, pid_t pid);
int sendReserveMsg(int sockfd, char *command, char *params);
void sendServerAdaptMsg(int sockfd, char *mask, char *processingLimit);
void sndMsgClient(int sockfd, char *msg, int msgLen);
void receiveACK(int sockfd);
void sendACK(int sockfd);

extern void error(char *msg);

#endif
