#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <stdlib.h>

pid_t pid;
unsigned long last_prime = 2;
int primes;

void finish()
{
    printf("Process %d found %d primes. Last prime: %lu\n", getpid(), primes, last_prime);
    exit(0);
}

int is_prime(unsigned long n)
{
    unsigned long i;

    for (i = 3; i*i <= n; i++)
        if (n % i == 0)
            return 0;
    return 1;
}

int main(int argc, char **argv)
{
    int procs;
    unsigned long n = 3;
    int i;
    int limit;
    primes = 1;

    pid = getpid();

    if (argc > 1)
        procs = atoi(argv[1]);
    else
        procs = 1;

    if (argc > 2)
        limit = atoi(argv[2]);
    else
        limit = 0;

    for (i = 1; pid > 0 && i < procs; i++)
        pid = fork();

    signal(SIGINT, finish);

    while (1) {
        if (is_prime(n)) {
            last_prime = n;
            if (++primes == limit) {
                finish();
            }
        }
        n += 2;
    }

    return 0;
}
