#!/usr/bin/ruby

def findPrimes(id)

    primes = [2]
    isPrime = false
    lastPrime = -1
    numberOfPrimes = 1

    trap("INT") do
        puts "\n#{numberOfPrimes} primes found by id #{id}. Largest prime found: #{lastPrime}"
        exit
    end

    i = 3
    while true
        primes.each { |p|
            break if i % p == 0
            if p > Math.sqrt(i)
                isPrime = true
                break
            end
        }
        if isPrime
            primes.push(i)
            lastPrime = i
            isPrime = false
            numberOfPrimes += 1
        end
        i = i + 2;
    end

end

numberOfProcesses = 2

(numberOfProcesses - 1).times { |n|
    fork do
        findPrimes(n + 1)
    end
}
findPrimes(0)
