#ifndef _CPURESERVE_H_
#define _CPURESERVE_H_

#include <sstream>
#include <stdlib.h>
#include <map>
#include <vector>
#include "Log.h"
#include "ProcessList.h"

#define PORT 8000

class CPUReserve
{
	public:
		CPUReserve(int port) : log("CPUReserve.h"), port(port), processList(NULL) {}
		~CPUReserve();

		int getMask() {return mask;}
		int getNumberOfCPUs() {return numberOfCPUs;}
		int getCPULimit() {return cpuLimit;}
		bool updateStatus();
		ProcessList* getProcessList() {return processList;}
		void adapt(int cpuLimit, int bitmask);

		void parseStatus(string status);

	private:
		Log log;
		int port;
		int mask;
		int numberOfCPUs;
		int cpuLimit;
		ProcessList *processList;

		string getLine(string status, int start);
};
#endif
