#ifndef _PROCESSLIST_H_
#define _PROCESSLIST_H_

#include <string>
#include <vector>

using namespace std;

#include <iostream>

class Process
{
	public:
		Process();
		~Process();

		void addChild(Process *p) { children->push_back(p); }
		static Process* getNewProcess();
		vector<Process*>* getChildren() { return children; }
		bool isFather() { return father; }
		void setFather() { father = true; }

		int getCPU() { return cpu; }
		void setCPU(int v) { cpu = v; }
		string getMem() { return mem; }
		void setMem(string v) { mem = v; }
		void setName(string v) { name = v; }
		string getName() { return name; }
		int getPid() { return pid; }
		void setPid(int v) { pid = v; }

		operator bool() const { return (pid != -1); }
		bool operator== (Process p) { return (p.getPid() == pid); }
		bool operator!= (Process &p) { return (p.getPid() != pid); }

	private:
		int cpu;
		bool father;
		string mem;
		string name;
		int pid;
		vector<Process*> *children;
};

class ProcessList
{
	public:
		ProcessList();
		~ProcessList();
		void addLastParentChild(int pid);
		void addNewParent(int pid);
		vector<Process*>* getProcesses() { return processes; }
		string getTopCmd();
		void parseTopOutput(int numberOfCPUs);
		void killApp(int nApp);

		Process* getProcessByPid(int pid);

	private:
		vector<Process*> *processes;

		void kill();
};
#endif
