#include "ProcessListPage.h"
#include <sstream>
#include <stdlib.h>

/*
   ProcessListPage Methods
*/

void ProcessListPage::kill()
{
	mapStSt::iterator killApp = queryString.find("killApp");

	if (killApp != queryString.end()) {
		string nApp = killApp->second;
		processList->killApp(atoi(nApp.c_str()));
	}
}


void ProcessListPage::generateVars()
{
	kill();

	string list;
	ProcessPage processPage(this->processTpl);
	vector<Process*> *processes = processList->getProcesses();
	vector<Process*> *children;
	vector<Process*>::iterator parentIt, childIt;
	Process *parent, *child;

	for (parentIt = processes->begin(); parentIt < processes->end(); parentIt++) {
		parent = *parentIt;
		processPage.setProcess(parent);
		list.append(processPage.getPage());
		children = parent->getChildren();
		for (childIt = children->begin(); childIt < children->end(); childIt++) {
			child = *childIt;
			processPage.setProcess(child);
			list.append(processPage.getPage());
		}
	}

	setVar("PROCESS", list);
}


/* ProcessPage methods */
void ProcessPage::generateVars()
{
	ostringstream aux;

	aux << process->getCPU();
	setVar("CPU", aux.str());

	setVar("MEMORY", process->getMem());

	setVar("NAME", process->getName());

	aux.str("");
	aux << process->getPid();
	setVar("PID", aux.str());

	int nChildren = 0;
	if (process->isFather()) {
		nApp++;
		nChildren = process->getChildren()->size();
	}

	aux.str("");
	if (process->isFather())
		aux << "<td class=\"res\" rowspan=\"" << nChildren + 1 <<
			"\">" << nApp << "</td>" << endl;
	setVar("APP", aux.str());

	aux.str("");
	if (process->isFather())
		aux << "<td class=\"res\" rowspan=\"" << nChildren + 1 <<
			"\"><button onClick=\"location.href='process.ncc?killApp=" << nApp <<
			"'\">Migrate</button></td>" << endl;
	setVar("KILL", aux.str());
}
